DisplayPanel
Date: 2019-10-22

org.openscience.jmol.app.jmolpanel

## Class DisplayPanel

- java.lang.Object
- - java.awt.Component
  - - java.awt.Container
    - - javax.swing.JComponent
      - - javax.swing.JPanel
        - - org.openscience.jmol.app.jmolpanel.DisplayPanel

- All Implemented Interfaces:
    java.awt.event.ComponentListener, java.awt.image.ImageObserver, java.awt.MenuContainer, java.awt.print.Printable, java.io.Serializable, java.util.EventListener, javax.accessibility.Accessible, JmolFrame

      public class DisplayPanel
      extends javax.swing.JPanel
      implements JmolFrame, java.awt.event.ComponentListener, java.awt.print.Printable

  See Also:
    Serialized Form

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `private class` | `DisplayPanel.CheckBoxMenuItemAction` Action calling evalStringQuiet(<action> + CheckBoxState)
    `(package private) class` | `DisplayPanel.DefineCenterAction`
    `(package private) class` | `DisplayPanel.HomeAction`
    `private class` | `DisplayPanel.MoveToAction` Action calling moveTo()
    `private class` | `DisplayPanel.SetStatusAction` Action calling setStatus()

    - ### Nested classes/interfaces inherited from class javax.swing.JPanel

      `javax.swing.JPanel.AccessibleJPanel`

    - ### Nested classes/interfaces inherited from class javax.swing.JComponent

      `javax.swing.JComponent.AccessibleJComponent`

    - ### Nested classes/interfaces inherited from class java.awt.Container

      `java.awt.Container.AccessibleAWTContainer`

    - ### Nested classes/interfaces inherited from class java.awt.Component

      `java.awt.Component.AccessibleAWTComponent, java.awt.Component.BaselineResizeBehavior, java.awt.Component.BltBufferStrategy, java.awt.Component.FlipBufferStrategy`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private javax.swing.Action` | `axesAction`
    `(package private) java.awt.Point` | `border`
    `private javax.swing.Action` | `bottomAction`
    `private javax.swing.Action` | `boundboxAction`
    `(package private) javax.swing.AbstractButton` | `buttonModelkit`
    `(package private) javax.swing.AbstractButton` | `buttonRotate`
    `private DisplayPanel.DefineCenterAction` | `defineCenterAction`
    `private javax.swing.Action` | `deleteAction`
    `(package private) java.awt.Dimension` | `dimSize`
    `private java.lang.String` | `displaySpeed`
    `private javax.swing.JFrame` | `frame`
    `private javax.swing.Action` | `frontAction`
    `(package private) boolean` | `haveBorder`
    `(package private) boolean` | `haveDisplay`
    `private DisplayPanel.HomeAction` | `homeAction`
    `private javax.swing.Action` | `hydrogensAction`
    `(package private) JmolPanel` | `jmolPanel`
    `private int` | `lastMotionEventNumber`
    `private javax.swing.Action` | `leftAction`
    `private javax.swing.Action` | `measurementsAction`
    `(package private) MeasurementTable` | `measurementTable`
    `private javax.swing.Action` | `perspectiveAction`
    `private java.awt.Rectangle` | `rectClip`
    `private javax.swing.Action` | `rightAction`
    `private boolean` | `showPaintTime`
    `private java.awt.Dimension` | `startupDimension`
    `(package private) StatusBar` | `status`
    `private long` | `timeBegin`
    `private static int` | `timeCount`
    `private static int` | `timeLast`
    `private static int` | `timeTotal`
    `(package private) javax.swing.ButtonGroup` | `toolbarButtonGroup`
    `private javax.swing.Action` | `topAction`
    `(package private) Viewer` | `vwr`
    `private javax.swing.Action` | `xlateAction`
    `private javax.swing.Action` | `zoomAction`

    - ### Fields inherited from class javax.swing.JComponent

      `listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

    - ### Fields inherited from class java.awt.Component

      `accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

    - ### Fields inherited from interface java.awt.print.Printable

      `NO_SUCH_PAGE, PAGE_EXISTS`

    - ### Fields inherited from interface java.awt.image.ImageObserver

      `ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `DisplayPanel(JmolPanel jmol)`

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `componentHidden(java.awt.event.ComponentEvent e)`
    `void` | `componentMoved(java.awt.event.ComponentEvent e)`
    `void` | `componentResized(java.awt.event.ComponentEvent e)`
    `void` | `componentShown(java.awt.event.ComponentEvent e)`
    `private java.lang.String` | `fmt(int num)`
    `javax.swing.Action[]` | `getActions()`
    `javax.swing.JFrame` | `getFrame()`
    `(package private) boolean` | `isRotateMode()`
    `void` | `paint(java.awt.Graphics g)`
    `int` | `print(java.awt.Graphics g, java.awt.print.PageFormat pf, int pageIndex)`
    `private void` | `recordTime(int time)`
    `private void` | `resetTimes()`
    `void` | `say(java.lang.String msg)`
    `(package private) void` | `setBorder()`
    `void` | `setJmolSize(java.awt.Dimension d)`
    `(package private) void` | `setModelkitMode()`
    `(package private) void` | `setRotateMode()`
    `(package private) void` | `setViewer(Viewer vwr)`
    `private void` | `showTimes()`
    `void` | `start()`
    `private void` | `startPaintClock()`
    `private void` | `stopPaintClock()`
    `private void` | `updateSize(boolean doAll)`

    - ### Methods inherited from class javax.swing.JPanel

      `getAccessibleContext, getUI, getUIClassID, paramString, setUI, updateUI`

    - ### Methods inherited from class javax.swing.JComponent

      `addAncestorListener, addNotify, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBaseline, getBaselineResizeBehavior, getBorder, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, hide, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingForPrint, isPaintingOrigin, isPaintingTile, isRequestFocusEnabled, isValidateRoot, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeNotify, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setEnabled, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

    - ### Methods inherited from class java.awt.Container

      `add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, setLayout, transferFocusDownCycle, validate, validateTree`

    - ### Methods inherited from class java.awt.Component

      `action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isEnabled, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### status

          StatusBar status

    - #### vwr

          Viewer vwr

    - #### displaySpeed

          private java.lang.String displaySpeed

    - #### startupDimension

          private java.awt.Dimension startupDimension

    - #### haveDisplay

          boolean haveDisplay

    - #### border

          java.awt.Point border

    - #### haveBorder

          boolean haveBorder

    - #### measurementTable

          MeasurementTable measurementTable

    - #### jmolPanel

          JmolPanel jmolPanel

    - #### frame

          private javax.swing.JFrame frame

    - #### showPaintTime

          private boolean showPaintTime

    - #### dimSize

          final java.awt.Dimension dimSize

    - #### rectClip

          private final java.awt.Rectangle rectClip

    - #### buttonRotate

          javax.swing.AbstractButton buttonRotate

    - #### buttonModelkit

          javax.swing.AbstractButton buttonModelkit

    - #### toolbarButtonGroup

          javax.swing.ButtonGroup toolbarButtonGroup

    - #### homeAction

          private DisplayPanel.HomeAction homeAction

    - #### defineCenterAction

          private DisplayPanel.DefineCenterAction defineCenterAction

    - #### frontAction

          private javax.swing.Action frontAction

    - #### topAction

          private javax.swing.Action topAction

    - #### bottomAction

          private javax.swing.Action bottomAction

    - #### rightAction

          private javax.swing.Action rightAction

    - #### leftAction

          private javax.swing.Action leftAction

    - #### hydrogensAction

          private javax.swing.Action hydrogensAction

    - #### measurementsAction

          private javax.swing.Action measurementsAction

    - #### perspectiveAction

          private javax.swing.Action perspectiveAction

    - #### axesAction

          private javax.swing.Action axesAction

    - #### boundboxAction

          private javax.swing.Action boundboxAction

    - #### deleteAction

          private javax.swing.Action deleteAction

    - #### zoomAction

          private javax.swing.Action zoomAction

    - #### xlateAction

          private javax.swing.Action xlateAction

    - #### timeLast

          private static int timeLast

    - #### timeCount

          private static int timeCount

    - #### timeTotal

          private static int timeTotal

    - #### timeBegin

          private long timeBegin

    - #### lastMotionEventNumber

          private int lastMotionEventNumber

  - ### Constructor Detail

    - #### DisplayPanel

          DisplayPanel(JmolPanel jmol)

  - ### Method Detail

    - #### getFrame

          public javax.swing.JFrame getFrame()

      Specified by:
        `getFrame` in interface `JmolFrame`

    - #### say

          public void say(java.lang.String msg)

    - #### setViewer

          void setViewer(Viewer vwr)

    - #### start

          public void start()

    - #### isRotateMode

          boolean isRotateMode()

    - #### setRotateMode

          void setRotateMode()

    - #### setModelkitMode

          void setModelkitMode()

    - #### componentHidden

          public void componentHidden(java.awt.event.ComponentEvent e)

      Specified by:
        `componentHidden` in interface `java.awt.event.ComponentListener`

    - #### componentMoved

          public void componentMoved(java.awt.event.ComponentEvent e)

      Specified by:
        `componentMoved` in interface `java.awt.event.ComponentListener`

    - #### componentResized

          public void componentResized(java.awt.event.ComponentEvent e)

      Specified by:
        `componentResized` in interface `java.awt.event.ComponentListener`

    - #### componentShown

          public void componentShown(java.awt.event.ComponentEvent e)

      Specified by:
        `componentShown` in interface `java.awt.event.ComponentListener`

    - #### updateSize

          private void updateSize(boolean doAll)

    - #### paint

          public void paint(java.awt.Graphics g)

      Overrides:
        `paint` in class `javax.swing.JComponent`

    - #### setBorder

          void setBorder()

    - #### print

          public int print(java.awt.Graphics g,
                           java.awt.print.PageFormat pf,
                           int pageIndex)

      Specified by:
        `print` in interface `java.awt.print.Printable`

    - #### getActions

          public javax.swing.Action[] getActions()

    - #### resetTimes

          private void resetTimes()

    - #### recordTime

          private void recordTime(int time)

    - #### startPaintClock

          private void startPaintClock()

    - #### stopPaintClock

          private void stopPaintClock()

    - #### fmt

          private java.lang.String fmt(int num)

    - #### showTimes

          private void showTimes()

    - #### setJmolSize

          public void setJmolSize(java.awt.Dimension d)